#!/bin/sh
# ~/my-applications/bin/SauvPerso.sh
# AND 
# /etc/init.d/start_SauvPerso.sh
#
# Objectif :
# Script généraliste pour créer un fichier de sauvegarde personnel (pupsave)
# Devrait convenir à tous les Toutous ou Puppys récents.
#
# Purpose:
# / Generalist script to create a pupsave file. Should fit all recent Puppies.
# musher0, Febr. 11, 2014
####
echo
if [ ${LANG:0:2} = "fr" ];then
	echo "Voulez-vous créer un fichier de sauvegarde personnel maintenant ?"
	echo "Tapez o ou O pour oui, n ou N pour non.'"
	else
		echo "Do you wish to create a pupsave file now?"
		echo "Type y or Y for yes, n or N for no.'"
fi
read Z
echo
case $Z in
	o|O|y|Y)cd /etc
# 0) Vérifier si /mnt/home existe (donc pas 1ère session) 
# Cette partie "0" est encore expérimentale -- pour démarrage d'un CD.
# 0) Check if /mnt/home exists (if so, not 1st session)
# This segment "0" is still experimental -- for boot from CD.
	if [ ! -d /mnt/home ];then 
		if [ ${LANG:0:2} = "fr" ];then
			echo "S.v.p. définir 'home'."
			echo "Taper seulement les 2 derniers caractères."
			echo "Par exemple, pour sdb1, taper 'b1'."
			else 
				echo "Please define 'home'."
				echo "Type only the last 2 characters."
				echo "For example, for sdb1, type 'b1'."
		fi
		echo "`probepart | awk -F"|" '$2 ~ /ext/ { print $1 }' | awk -F"/" ' { print $3 }' | tr '\n' ' '`"
		echo
		read HM
		mount /dev/sd$HM /mnt/home
	fi
# 1) Crée un dossier portant le nom du Toutou.  / 
# Creates a folder bearing the name of the Puppy.
	DS="DISTRO_SPECS"
	A="`awk -F"=" '$1=="DISTRO_FILE_PREFIX" { print $2 }' $DS | cut -d\"'\" -f2`"
	B="`awk -F"=" '$1=="DISTRO_VERSION" { print $2 }' $DS`"
	[ ! -d /mnt/home/"$A"-"$B" ] && mkdir -p /mnt/home/"$A"-"$B"
	
# 2) Création du fichier de sauvegarde comme tel. / 
# Creation of the pupsave file per se.
	C="$A"
	echo
	if [ ${LANG:0:2} = "fr" ];then
		echo "Veuillez choisir le type de système de fichiers pour"
		echo "votre fichier de sauvegarde personnel ('pupsave')."
		echo "ext2, ext3 ou ext4. (Tapez 2, 3 ou 4.)"
		else
			echo "Please choose the type of file system"
			echo "for your pupsave file."
			echo "ext2, ext3 ou ext4. (Type 2, 3 ou 4.)"
	fi
	read d;[ "$d" -lt "2" ] && d="2";[ "$d" -gt "4" ] && d="4"
	echo
	if [ ${LANG:0:2} = "fr" ];then
		echo "Veuillez choisir la taille de votre fichier de sauvegarde"
		echo "personnel ('pupsave'), en multiples de 192Mo."
		echo "Tapez 1, 2, 3, 4 ou 5."
		else
			echo "Please select the size of your"
			echo "pupsave file, in multiples of 192Mb."
			echo "Type 1, 2, 3, 4 or 5."
	fi
	read e;[ "$e" -lt "1" ] && e="1";[ "$e" -gt "5" ] && e="5"
	E="`expr $e \* 196608`"
	echo
	if [ ${LANG:0:2} = "fr" ];then
		echo "Veuillez taper un nom distinctif court pour le fichier de sauvegarde."
		echo "Le 1er caractère doit être une lettre. Aucune ponctuation s.v.p.'"
		echo "Attention aux fautes de frappe ! Aucune vérification n'est faite."
		else
			echo "Please type a short distinctive 'middle' name for the pupsave file."
			echo "The first character must be a letter. No punctuation please."
			echo "Watch out for typos! No spell-checking is done."
	fi
	read f
	echo
# 3) Action
	[ ${LANG:0:2} = "fr" ] && echo "Opération en cours..." || echo "Operation under way..."
	echo
	cd /mnt/home/"$A"-"$B"
	dd if=/dev/zero of="$C"save-"$f"."$d"fs bs=1k count="$E"
	mkfs.ext"$d" -q -m 0 -F "$C"save-"$f"."$d"fs
	echo
# 4) Résultat / # Result
	if [ ${LANG:0:2} = "fr" ];then
		echo " C'est fait !"
		echo " S.v.p. redémarrer pour activer ce fichier."
		else
			echo " It is done!"
			echo " Please reboot to activate this pupsave."
	fi
	rox /mnt/home/"$A"-"$B" &
#5) Option redémarrer / # Reboot option
	if [ ${LANG:0:2} = "fr" ];then
		echo "(Pour redémarrer, tapez 'Ctrl-Alt-BackSpace', puis 'reboot')."
		else
			echo "(To reboot, type 'Ctrl-Alt-BackSpace', then 'reboot'.)"
	fi
	read
	;;

	*)if [ ${LANG:0:2} = "fr" ];then
		echo "D'accord. Ce sera pour une autre fois."
		else
			echo "Very well then. 'til next time."
	fi
	echo
	exit
	;;
esac
